
# Goal: Identify the principal components and the total variance explained by the components

# Defining function for performing the necessary operations

def pca():
  
  # Importing necessary libraries
  import numpy as np
  import cdsw
  import matplotlib.pyplot as plt
  from sklearn import decomposition
  from sklearn import datasets
  from sklearn.datasets import load_digits
  import seaborn as sns
  
  
  # Loading the dataset
  # Dataset: MNIST dataset
  digits = load_digits()
  
  # Defining the inpout and output variables
  X = digits.data
  y = digits.target
  
  pca = decomposition.PCA(n_components=2)
  principalComponents = pca.fit_transform(X)
  
# attaching the label for each 2-d data point 
  pca_data = np.vstack((principalComponents.T, y)).T
  import pandas as pd
# creating a new data fram which help us in ploting the result data
  pca_df = pd.DataFrame(data=pca_data, columns=("1st_principal", "2nd_principal", "label"))
  sns.FacetGrid(pca_df, hue="label", size=6).map(plt.scatter, '1st_principal', '2nd_principal').add_legend()
  plt.show()
  
# Below code helps when experiments are run and system arguments are passed to calculate the number of principal components  
#args = sys.argv
#print(args[0])
#type(args)

pca()

def umap():
  
  
  import numpy as np

  import matplotlib.pyplot as plt
  from sklearn import decomposition
  from sklearn import datasets
  from sklearn.datasets import load_digits
  
  
  # Loading the dataset
  # Dataset: MNIST dataset
  digits = load_digits()
  
  # Defining the inpout and output variables
  X = digits.data
  y = digits.target
  
  import umap
  import matplotlib.pyplot as plt
  import seaborn as sns

  sns.set(context="paper", style="white")

  reducer = umap.UMAP(random_state=42,min_dist=0.8)
  embedding = reducer.fit_transform(digits.data)

  fig, ax = plt.subplots(figsize=(12, 10))
  plt.scatter(
    embedding[:, 0], embedding[:, 1], c=y, cmap="Spectral", s=4
  )
  plt.setp(ax, xticks=[], yticks=[])
  plt.title("MNIST data embedded into two dimensions by UMAP", fontsize=18)

  plt
  
umap()


def tsne():
  
  import numpy as np
  from sklearn import decomposition
  from sklearn import datasets
  from sklearn.datasets import load_digits
  
  
  # Loading the dataset
  # Dataset: MNIST dataset
  digits = load_digits()
  
  # Defining the inpout and output variables
  X = digits.data
  y = digits.target
  
  import umap
  import matplotlib.pyplot as plt
  import seaborn as sns
  from sklearn.manifold import TSNE
 

  sns.set(context="paper", style="white")

  tsne = TSNE(n_components=2, random_state=0)
  embedding = tsne.fit_transform(X)

  fig, ax = plt.subplots(figsize=(12, 10))
  plt.scatter(
    embedding[:, 0], embedding[:, 1], c=y, cmap="Spectral", s=6
  )
  plt.setp(ax, xticks=[], yticks=[])
  plt.title("MNIST data embedded into two dimensions by TSNE", fontsize=18)

  plt
tsne()