# Below function is used to calculate the principal components
def pca(n_components):
  
  # Importing necessary libraries
  import numpy as np
  import cdsw
  import matplotlib.pyplot as plt
  from sklearn import decomposition
  from sklearn import datasets
  from sklearn.datasets import load_digits
  
  
  # Loading the dataset
  # Dataset: MNIST dataset
  digits = load_digits()
  
  # Defining the inpout and output variables
  X = digits.data
  y = digits.target
  
  # Defining an instance fot compiling the principal components using scikit-learn
  # n_components define number of principal components to be computed
  pca = decomposition.PCA(n_components)
  
  # Fit the input values to the computed principal components
  pca.fit(X)
  
  # Transform the inputs to lower dimensions using PCA
  X = pca.transform(X)
  
  # Print the explained variance by the principal components
  explained_variance=pca.explained_variance_ratio_
  print(explained_variance)
  
  # Here we are using CDSW metrics to keep track of number of principal documents calculated
  cdsw.track_metric('principal_components', n_components)

# Below code helps when experiments are run and system arguments are passed to calculate the number of principal components  
# Uncomment the below code when you run your experiments
#args = sys.argv
#print(args[0])
#type(args)

pca(3)